/*
 * ----------------------------------------------------------------------------
 *  (C) Copyright Testing Technologies, 2001-2005.  All Rights Reserved.
 *
 *  All copies of this program, whether in whole or in part, and whether
 *  modified or not, must display this and all other embedded copyright
 *  and ownership notices in full.
 *
 *  See the file COPYRIGHT for details of redistribution and use.
 *
 *  You should have received a copy of the COPYRIGHT file along with
 *  this file; if not, write to the Testing Technologies,
 *  Rosenthaler Str. 13, 10119 Berlin, Germany.
 *
 *  TESTING TECHNOLOGIES DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 *  SOFTWARE. IN NO EVENT SHALL TESTING TECHNOLOGIES BE LIABLE FOR ANY
 *  SPECIAL, DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 *  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 *  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 *  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 *  THIS SOFTWARE.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 *  EITHER EXPRESSED OR IMPLIED, INCLUDING ANY KIND OF IMPLIED OR
 *  EXPRESSED WARRANTY OF NON-INFRINGEMENT OR THE IMPLIED WARRANTIES
 *  OF MECHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * -----------------------------------------------------------------------------
 *
 *  AUTHOR:      dte
 *  DATE:        Jun 11, 2005
 *
 *  REVISION INFO:
 *    $Revision: 1.2 $ $Date: 2005/06/22 14:44:34 $
 *    $Source: /net/ttech/cvs_root/IPv6_ETSI_STF276/javasrc/com/testingtech/ttcn/tri/BytesHash.java,v $
 *
 * -----------------------------------------------------------------------------
 */


package com.testingtech.ttcn.tri;

import java.math.BigInteger;

import com.testingtech.util.HexViewer;



/**
 * The intention of this class is to provide an object based on byte information 
 * usable as key for a hashmap.
 * 
 * @author dte
 *
 */
public class BytesHash {
	private byte [] f_bytes = null;
	
	/**
	 * The constructor of this class.
	 * Setting the bytes.
	 * 
	 * @param bytes
	 */
	public BytesHash(byte [] bytes) {
		super();
		f_bytes = bytes;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new BigInteger(this.f_bytes).hashCode();
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object ndam) {
		return new BigInteger(this.f_bytes).equals(new BigInteger(((BytesHash)ndam).f_bytes));
	}
	
	/**
	 * @return Returns the f_bytes.
	 */
	public byte [] getBytes() {
		return f_bytes;
	}

	/**
	 * @param bytes The f_bytes to set.
	 */
	public void setBytes(byte [] bytes) {
		f_bytes = bytes;
	}

	/**
	 * Returns a string in the format "BytesHash: " + bytes in hex representation.
	 */
    public String toString() {
    	return "BytesHash: " + HexViewer.hexString(f_bytes) + "\n";
    }
}
